<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

//Session-ID verlangen
if(!isset($_GET["sesid"])) exit;

//Session laden
if(FALSE === session_id($_GET["sesid"])) exit;
if(FALSE === session_start()) exit;

//Send headers to ensure latin1 charset
header('Content-Type: text/html; charset=ISO-8859-1');

error_reporting(0);
$ko_menu_akt = 'admin';
$ko_path = "../../";
require($ko_path."inc/ko.inc");
$ko_path = "../";

//Get access rights
ko_get_access('admin');

//Include KOTA for sms log
ko_include_kota(array('_ko_sms_log'));

// Plugins einlesen:
$hooks = hook_include_main("admin");
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);

//Smarty-Templates-Engine laden
require($BASE_PATH."inc/smarty.inc");

require($BASE_PATH."admin/inc/admin.inc");

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);

hook_show_case_pre($_SESSION['show']);


if(isset($_GET) && isset($_GET["action"])) {
	$action = format_userinput($_GET["action"], "alphanum");
	switch($action) {

		case "setsortlog":
			if($access['admin']['MAX'] < 4) continue;

			$_SESSION["sort_logs"] = format_userinput($_GET["sort"], "alphanum+", TRUE, 30);
			$_SESSION["sort_logs_order"] = format_userinput($_GET["sort_order"], "alpha", TRUE, 4);

			print "main_content@@@";
			ko_show_logs(FALSE);
		break;


		case "setstart":
			if($access['admin']['MAX'] < 1) continue;

			//Start fr Listenansicht setzen
			if(FALSE === ($_SESSION["show_start"] = format_userinput($_GET["set_start"], "uint"))) {
    	  $_SESSION["show_start"] = 1;
	    }

			print "main_content@@@";
			if($_SESSION['show'] == 'show_sms_log') {
				print ko_show_sms_log(FALSE);
			} else {
				print ko_set_logins_list(FALSE);
			}
		break;


		case "setstartlogs":
			if($access['admin']['MAX'] < 1) continue;

			//Start fr Listenansicht setzen
			if(FALSE === ($_SESSION["show_logs_start"] = format_userinput($_GET["set_start"], "uint"))) {
    	  $_SESSION["show_logs_start"] = 1;
	    }

			print "main_content@@@";
			print ko_show_logs(FALSE);
		break;


		case "ablelogin":
			if($access['admin']['MAX'] < 4) continue;

			$id = format_userinput($_GET["id"], "uint");
			if($id == ko_get_root_id() || $id == ko_get_guest_id()) continue;

			if($_GET["mode"] == "enabled") {
				$orig_hash = db_select_data("ko_admin", "WHERE `id` = '$id'", "disabled", "", "", TRUE);
				$data = array("password" => $orig_hash["disabled"], "disabled" => "");
			} else if($_GET["mode"] == "disabled") {
				$orig_hash = db_select_data("ko_admin", "WHERE `id` = '$id'", "password", "", "", TRUE);
				$data = array("password" => md5($orig_hash), "disabled" => $orig_hash["password"]);
			} else continue;

			db_update_data("ko_admin", "WHERE `id` = '$id'", $data);

			print "main_content@@@";
			print ko_set_logins_list(FALSE);
		break;


	}//switch(action);
}//if(GET[action])
?>
