--
-- kOOL - the church tool
-- www.churchtool.org
--
-- IMPORTANT: Run update_R40.php first to convert the smallgroup membership
-- 
-- DB changes needed for update from R39a to R40
-- Important: Update DB before updating source
--



-- Add help texts for ical links
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'daten', 'ical_links', 'en', '48', '152', NULL), ( NULL , 'daten', 'ical_links', 'de', '48', '415', NULL);
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'daten', 'ical_links2', 'en', '', '', 'Right click on link and select "Copy link" to add the link to your clipboard. Paste it into your calendar application.'), ( NULL , 'daten', 'ical_links2', 'de', '', '', 'Mit der rechten Maustaste auf den gewnschten Link klicken und "Link-Adresse kopieren". Danach im Kalender-Programm als Kalender-URL einfgen.');
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'reservation', 'ical_links', 'en', '45', '1002', NULL), ( NULL , 'reservation', 'ical_links', 'de', '45', '1003', NULL);
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'reservation', 'ical_links2', 'en', '', '', 'Right click on link and select "Copy link" to add the link to your clipboard. Paste it into your calendar application.'), ( NULL , 'reservation', 'ical_links2', 'de', '', '', 'Mit der rechten Maustaste auf den gewnschten Link klicken und "Link-Adresse kopieren". Danach im Kalender-Programm als Kalender-URL einfgen.');


-- New table to define preferred fields in ko_leute
CREATE TABLE `ko_leute_preferred_fields` (
  `id` mediumint(9) unsigned NOT NULL auto_increment,
  `type` varchar(50) NOT NULL,
  `lid` mediumint(9) unsigned NOT NULL,
  `field` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `type` (`type`),
  KEY `lid` (`lid`),
  KEY `field` (`field`)
);



-- iCal deadline settings
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ( 'daten_ical_deadline', '0'), ( 'res_ical_deadline', '0');


-- new filter to find duplicates
INSERT INTO `ko_filter` (`id`, `typ`, `dbcol`, `name`, `allow_neg`, `sql1`, `sql2`, `sql3`, `numvars`, `var1`, `code1`, `var2`, `code2`, `var3`, `code3`) VALUES(NULL, 'leute', '', 'duplicates', 0, '', '', '', 1, 'test field', 'FCN:ko_specialfilter_duplicates', '', '', '', '');


-- Help texts for merging duplicates
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'leute', 'merge_duplicates', 'en', '47', '1068', NULL), ( NULL , 'leute', 'merge_duplicates', 'de', '47', '1069', NULL);



-- Google calendar URL field for event groups
ALTER TABLE `ko_eventgruppen` ADD `type` TINYINT NOT NULL DEFAULT '0';
ALTER TABLE `ko_eventgruppen` ADD `gcal_url` VARCHAR(250) NOT NULL;
ALTER TABLE `ko_eventgruppen` ADD INDEX ( `type` ) ;


-- New admin mobile field for logins
ALTER TABLE `ko_admin` ADD `mobile` VARCHAR( 50 ) NOT NULL ;


-- New column group for filters
ALTER TABLE `ko_filter` ADD `group` VARCHAR( 20 ) NOT NULL AFTER `name` ;
ALTER TABLE `ko_filter` ADD INDEX ( `group` ) ;

UPDATE ko_filter SET `group` = 'person' WHERE `name` IN ('salutation', 'last name', 'first name', 'address', 'address2', 'zip code', 'city', 'country', 'firm', 'department', 'Firma', 'Abteilung');
UPDATE ko_filter SET `group` = 'com' WHERE `name` IN ('tel p', 'tel b', 'mobile', 'fax', 'email', 'url');
UPDATE ko_filter SET `group` = 'family' WHERE `name` IN ('children', 'family', 'family role', 'addchildren', 'addparents');
UPDATE ko_filter SET `group` = 'groups' WHERE `name` IN ('team', 'team leader', 'group', 'rota', 'role', 'grp data');
UPDATE ko_filter SET `group` = 'misc' WHERE `name` IN ('memo1', 'memo2', 'duplicates', 'last change', 'filterpreset', 'crdate', 'donation');
UPDATE ko_filter SET `group` = 'smallgroup' WHERE `name` IN ('smallgroup', 'smallgrouproles', 'sg region', 'sg type', 'sg day');
UPDATE ko_filter SET `group` = 'status' WHERE `name` IN ('civil status', 'birthdate', 'sex', 'age', 'year');


-- Change ko_tracking.mode to varchar(20) to hold new type 'valueNonNum'
ALTER TABLE `ko_tracking` CHANGE `mode` `mode` VARCHAR( 20 ) NULL DEFAULT NULL;


-- Add new column to store the userid for moderations entered by logged in users
ALTER TABLE `ko_leute_mod` ADD `_cruserid` MEDIUMINT UNSIGNED NOT NULL;


-- Change ko_admin.disabled to NOT NULL
ALTER TABLE `ko_admin` CHANGE `disabled` `disabled` VARCHAR( 32 ) NOT NULL , CHANGE `admingroups` `admingroups` TEXT NOT NULL , CHANGE `email` `email` VARCHAR( 255 ) NOT NULL;
